--Set path variables
local path = minetest.get_modpath(minetest.get_current_modname()) .. "/warps/warps/"
local modpath = minetest.get_modpath(minetest.get_current_modname())

--Load configuration
dofile(modpath..'/warps/config.txt')

--Warp checker function
local function costwarp(name, param)
		local player = minetest.env:get_player_by_name(name)
		
		--Check if Cost_to_warp is enabled in config.
		if Cost_to_warp ~= false then
		
			--If so, check if Cost_to_warp is set to item.
			if Cost_to_warp == item then
			
				--Register and check Itemstack
				local itemstack = ItemStack(Warp_item ..' '.. Warp_item_amount)
				
				--If Config variable does not exist
				if itemstack:is_empty() then
					minetest.chat_send_player(name, 'Error: cannot take an empty item. Please contact the server administrator.')
					print('Error: cannot take an empty item. Please contact the server administrator.')

				return
				
				--If Config variable is unknown.
				elseif not itemstack:is_known() then
					minetest.chat_send_player(name, 'Error: cannot take an unknown item. Please contact the server administrator.')
					print('Error: cannot take an unknown item. Please contact the server administrator.')

				return
				else
				
				--If everything checks out ok, take the item and warp the player
					local playername = minetest.env:get_player_by_name(name)
					if playername:get_inventory():contains_item("main", itemstack) then
						playername:get_inventory():remove_item("main", itemstack)
						warp(name, param)
						print("success")
					else
					
					--If the player does not have the needed item, tell them that and do not warp.
					minetest.chat_send_player(name, 'You need to have '..Warp_item_amount..' '..Warp_item..'s to warp to a location.')
					return
					end
				end
			end
		else
		
		--If Cost_to_warp is set to false, warp the player.
		warp(name, param)
		end
end

--Set warp function
function setwarp(name, param)

		--Check for a warp name, if none exists, notify player.
		if param == nil or param == "" then
			minetest.chat_send_player(name, 'Please provide a warp name.')
			return
		else
			--Register variables
			local player = minetest.env:get_player_by_name(name)
			local ppos = player:getpos()
			local msg = 'Warp '..param..' set!'
			local file = io.open(path..'/'..param..'.txt','w')
			
			--Check for warp folder/write file
			if file ~= nil then
				print('Player '..name..'has set warp '..param..'.')
				file:write("warpx = "..tostring(ppos.x).."\n")
				file:write("warpy = "..tostring(ppos.y).."\n")
				file:write("warpz = "..tostring(ppos.z).."\n")
				file:close()
				
				--Notify player that warp has been set.
				minetest.chat_send_player(name, msg)
			else
				
				--If unable to create file, notify player/console.
				print("Error: Unable to locate warp folder.")
				minetest.chat_send_player(name, 'Unable to find warp folder, please contact an admin.')
			end
		end
end

--Warp function
function warp(name, param)

	--If no warp is specified, notify player.
	if param == nil or param == "" then
		minetest.chat_send_player(name, 'Please specify a valid warp.')
	return
	else
		--Check to see if warp exists. If so, teleport player
		local f = io.open(path..'/'..param..'.txt');
		if (f) then
			local player = minetest.env:get_player_by_name(name)
			
			--Load warp file
			dofile(path.."/"..param..'.txt')
			if warpx ~= nil then
			
				--Warp and tell player
				minetest.chat_send_player(name, 'Warping to location...')
				player:setpos({x=warpx,y=warpy,z=warpz})
			return
			end
		else
		
			--If warp file does not exist, notify player.
			minetest.chat_send_player(name, 'Warp does not exist.')
			return false;
		end
	end
end

--Delete warp function
function delwarp(name, param)
	
	--If no warp is specified, notify player
	if param == nil or param == "" then
		minetest.chat_send_player(name, 'Please specify a valid warp.')
	return
	else
		
		--Check if warp exists. If so, delete the warp.
		local f = io.open(path..'/'..param..'.txt');
		if (f) then
			f:close()
			os.remove(path..'/'..param..'.txt')
			minetest.chat_send_player(name, 'Warp removed!')
			return
		else
		
			--If warp does not exist, notify player.
			minetest.chat_send_player(name, 'Warp does not exist.')
			return false;
		end
	end
end

--Register Commands
minetest.register_chatcommand('warp',{
	description = 'Warp to location',
	privs = {se_warps = true},
	func = costwarp
})

minetest.register_chatcommand('setwarp',{
	description = 'Set a warp',
	params = "<warpname> | name of warp",
	privs = {se_admin = true},
	func = setwarp
})

minetest.register_chatcommand('delwarp',{
	description = 'Delete a warp',
	params = "<warpname> | name of warp",
	privs = {se_admin = true},
	func = delwarp
})
